<template>
  <div class="sw-product-gallery gallery gallery-big" ref="imageRef">
    <div v-if="mediaGallery.length > 0" class="gallery__mobile">
      <slot name="mobile-galery" v-bind="mediaGallery">
        <SwGsGalleryBig class="gallery-mobile gallery-mobile-big"
                        :configuration="config"
                        :images="mediaGallery">
        </SwGsGalleryBig>
      </slot>
    </div>
  </div>
</template>

<script>
  import SwGsGalleryBig from "./../SwGsGalleryBig.vue";
  import { getProductMediaGallery } from "@shopware-pwa/helpers"
  import getResizedImage from "@/helpers/images/getResizedImage.js"

  export default {
    name: "SwGsProductGallery",
    components: { SwGsGalleryBig },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
      content: {
        type: Object,
        default: () => ({}),
      },
      configuration: {
        type: Object,
        default: () => ({}),
      },
    },
    computed: {
      mediaGallery() {
        const width =
          this.$refs.imageRef?.$el?.getBoundingClientRect()?.width || 400
        const height =
          this.$refs.imageRef?.$el?.getBoundingClientRect()?.height || 600
        if (this.product.value) {
          return getProductMediaGallery({product: this.product}).map(
            (element) => {
              return {
                desktop: {
                  url: getResizedImage(element.desktop?.url, {width, height}),
                },
                mobile: {
                  url: getResizedImage(element.mobile?.url, {width, height}),
                },
                icon: {
                  url: getResizedImage(element.icon?.url, {width, height}),
                },
                alt: element.alt || "gallery image",
              }
            }
          )
        } else {
          return this.content.data.sliderItems.map(
            (element) => {
              return {
                desktop: {
                  url: getResizedImage(element.media?.url, {width, height}),
                },
                mobile: {
                  url: getResizedImage(element.media?.url, {width, height}),
                },
                icon: {
                  url: getResizedImage(element.media?.url, {width, height}),
                },
                alt: element.alt || "gallery image",
              }
            }
          )
        }
      },
    },
    setup(props) {
      const config = props?.configuration;
      return {
        config
      }
    },
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .gallery__mobile .sf-gallery {
    ::v-deep .sf-image:not(.sf-image-loaded) {
      opacity: 0;
      position: relative;
    }
  }

  .gallery-mobile-big {
    ::v-deep {
      .sf-gallery__stage {
        max-width: 100%;
      }
    }
  }
</style>
